(document:surround "/std/base")
(document:surround "/std/functions")

;; write down all checkbox settings via backend
(define (apply-to-backend) 
  (woo-write "/dovecot"
	     'disable_plaintext_auth (disable_plaintext_auth value)
	     'protocols (protocols value)
	     'mechanisms (mechanisms value)))


;; reset all checkboxes using data from backend
(define (reset-from-backend)
  (woo-catch/message
    (thunk 
      (let ((data (woo-read-first "/dovecot")))
	(disable_plaintext_auth value (woo-get-option data 'disable_plaintext_auth))
	(protocols value (woo-get-option data 'protocols))
	(mechanisms value (woo-get-option data 'mechanisms))))))

;;;

(define (apply-and-reset)
 (apply-to-backend)
 (reset-from-backend))

(gridbox
  columns "50;0;50"
  ;;
  (spacer)
  (label text (_ "Supported protocols:"))
  (spacer)
  ;;
  (spacer)
  (document:id protocols (checklistbox))
  (spacer)
  ;;
  (spacer)
  (label text (_ "Auth mechanisms:"))
  (spacer)
  ;;
  (spacer)
  (document:id mechanisms (checklistbox))
  (spacer)
  ;;
  (spacer)
  (label text (small (_ "(you can't disable all mechanisms)")))
  (spacer)
  ;;
  (label colspan 3)
  ;;
  (spacer)
  (document:id disable_plaintext_auth
    (checkbox text (_ "Allow plaintext authentification only on secure connections")))
  (spacer)
  ;;
  (spacer)
  (hbox align "left"
	   (button (_ "Apply") (when clicked (apply-and-reset)))
	   (button (_ "Reset") (when clicked (reset-from-backend))))
  (spacer))

(document:root
   (when loaded
      (woo-catch/message
        (thunk
          (protocols enumref "/dovecot/avail_protocols")
          (mechanisms enumref "/dovecot/avail_mechanisms")
          (reset-from-backend)))))
